--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_xioctl.c	Mon Aug  5 17:28:45 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_xioctl.c	Mon Aug  5 17:28:45 2019
@@ -2658,7 +2766,7 @@
 		    "d_id=%xh\n", cmd->Status, sts.comp_status, tq->d_id.b24);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_9(CE_CONT, "(%d): done, ResponseLen=%d\n",
+		QL_PRINT_9(ha, "done, ResponseLen=%d\n",
 		    ha->instance, cmd->ResponseLen);
 	}
 
@@ -2686,7 +2794,7 @@
 	EXT_SCSI_ADDR	*tmp_addr;
 	ql_tgt_t	*tq;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (cmd->RequestLen != EXT_DEF_WWN_NAME_SIZE) {
 		/* Return error */
@@ -2724,7 +2832,7 @@
 		EL(ha, "failed, ddi_copyout\n");
 	} else {
 		cmd->Status = EXT_STATUS_OK;
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -2748,7 +2856,7 @@
 {
 	uint16_t	idx;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (cmd->ResponseLen < sizeof (uint16_t)) {
 		cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
@@ -2767,7 +2875,7 @@
 		EL(ha, "failed, ddi_copyout\n");
 	} else {
 		cmd->ResponseLen = sizeof (uint16_t);
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -2793,9 +2901,9 @@
 	char		drvname[] = QL_NAME;
 	uint32_t	qlnamelen;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	qlnamelen = (uint32_t)(strlen(QL_NAME)+1);
+	qlnamelen = (uint32_t)(strlen(QL_NAME) + 1);
 
 	if (cmd->ResponseLen < qlnamelen) {
 		cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
@@ -2813,10 +2921,10 @@
 		cmd->ResponseLen = 0;
 		EL(ha, "failed, ddi_copyout\n");
 	} else {
-		cmd->ResponseLen = qlnamelen-1;
+		cmd->ResponseLen = qlnamelen - 1;
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -2838,7 +2946,7 @@
 ql_read_nvram(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
 {
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (cmd->ResponseLen < ha->nvram_cache->size) {
 		cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
@@ -2857,7 +2965,7 @@
 		EL(ha, "failed, copy error\n");
 	} else {
 		cmd->ResponseLen = ha->nvram_cache->size;
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -2880,7 +2988,7 @@
 ql_write_nvram(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
 {
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (cmd->RequestLen < ha->nvram_cache->size) {
 		cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
@@ -2897,7 +3005,7 @@
 		EL(ha, "failed, copy error\n");
 	} else {
 		/*EMPTY*/
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -2919,11 +3027,11 @@
 static void
 ql_write_vpd(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
 {
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	int32_t		rval = 0;
 
-	if ((CFG_IST(ha, CFG_CTRL_24258081)) == 0) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1)) {
 		cmd->Status = EXT_STATUS_INVALID_REQUEST;
 		EL(ha, "failed, invalid request for HBA\n");
 		return;
@@ -2945,7 +3053,7 @@
 		EL(ha, "failed, errno=%x\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -2967,9 +3075,9 @@
 static void
 ql_read_vpd(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
 {
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	if ((CFG_IST(ha, CFG_CTRL_24258081)) == 0) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1)) {
 		cmd->Status = EXT_STATUS_INVALID_REQUEST;
 		EL(ha, "failed, invalid request for HBA\n");
 		return;
@@ -2990,7 +3098,7 @@
 		EL(ha, "failed,\n");
 	} else {
 		/*EMPTY*/
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -3015,18 +3123,15 @@
 	uint32_t	bsize, boff, types, cpsize, hsize;
 	ql_fcache_t	*fptr;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	CACHE_LOCK(ha);
-
 	if (ha->fcache == NULL) {
-		CACHE_UNLOCK(ha);
 		cmd->Status = EXT_STATUS_ERR;
 		EL(ha, "failed, adapter fcache not setup\n");
 		return;
 	}
 
-	if ((CFG_IST(ha, CFG_CTRL_24258081)) == 0) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1)) {
 		bsize = 100;
 	} else {
 		bsize = 400;
@@ -3033,7 +3138,6 @@
 	}
 
 	if (cmd->ResponseLen < bsize) {
-		CACHE_UNLOCK(ha);
 		cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
 		cmd->DetailStatus = bsize;
 		EL(ha, "failed, ResponseLen < %d, len passed=%xh\n",
@@ -3058,7 +3162,6 @@
 			if (ddi_copyout(fptr->buf,
 			    (void *)(uintptr_t)(cmd->ResponseAdr + boff),
 			    cpsize, mode) != 0) {
-				CACHE_UNLOCK(ha);
 				EL(ha, "ddicopy failed, done\n");
 				cmd->Status = EXT_STATUS_COPY_ERR;
 				cmd->DetailStatus = 0;
@@ -3079,7 +3182,6 @@
 
 		hsize = sizeof (pci_header_t) + sizeof (pci_data_t);
 		if (hsize > fptr->buflen) {
-			CACHE_UNLOCK(ha);
 			EL(ha, "header size (%xh) exceeds buflen (%xh)\n",
 			    hsize, fptr->buflen);
 			cmd->Status = EXT_STATUS_COPY_ERR;
@@ -3090,10 +3192,9 @@
 		cpsize = ((fptr->buflen - hsize) < 100 ?
 		    fptr->buflen - hsize : 100);
 
-		if (ddi_copyout(fptr->buf+hsize,
+		if (ddi_copyout(fptr->buf + hsize,
 		    (void *)(uintptr_t)(cmd->ResponseAdr + 300),
 		    cpsize, mode) != 0) {
-			CACHE_UNLOCK(ha);
 			EL(ha, "fw ddicopy failed, done\n");
 			cmd->Status = EXT_STATUS_COPY_ERR;
 			cmd->DetailStatus = 0;
@@ -3102,11 +3203,10 @@
 		bsize += 100;
 	}
 
-	CACHE_UNLOCK(ha);
 	cmd->Status = EXT_STATUS_OK;
 	cmd->DetailStatus = bsize;
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -3131,11 +3231,9 @@
 	uint32_t	boff = 0;
 	ql_fcache_t	*fptr;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	CACHE_LOCK(ha);
 	if (ha->fcache == NULL) {
-		CACHE_UNLOCK(ha);
 		cmd->Status = EXT_STATUS_ERR;
 		EL(ha, "failed, adapter fcache not setup\n");
 		return;
@@ -3147,7 +3245,6 @@
 	}
 
 	if (cmd->ResponseLen < bsize) {
-		CACHE_UNLOCK(ha);
 		if (cmd->ResponseLen != 0) {
 			EL(ha, "failed, ResponseLen < %d, len passed=%xh\n",
 			    bsize, cmd->ResponseLen);
@@ -3165,7 +3262,6 @@
 		    (void *)(uintptr_t)(cmd->ResponseAdr + boff),
 		    (fptr->buflen < FBUFSIZE ? fptr->buflen : FBUFSIZE),
 		    mode) != 0) {
-			CACHE_UNLOCK(ha);
 			EL(ha, "failed, ddicopy at %xh, done\n", boff);
 			cmd->Status = EXT_STATUS_COPY_ERR;
 			cmd->DetailStatus = 0;
@@ -3175,11 +3271,10 @@
 		fptr = fptr->next;
 	}
 
-	CACHE_UNLOCK(ha);
 	cmd->Status = EXT_STATUS_OK;
 	cmd->DetailStatus = bsize;
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -3202,10 +3297,12 @@
 {
 	ql_xioctl_t	*xp = ha->xioctl;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	if (ql_stall_driver(ha, 0) != QL_SUCCESS) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1) &&
+	    ql_stall_driver(ha, 0) != QL_SUCCESS) {
 		EL(ha, "ql_stall_driver failed\n");
+		ql_restart_driver(ha);
 		cmd->Status = EXT_STATUS_BUSY;
 		cmd->DetailStatus = xp->fdesc.flash_size;
 		cmd->ResponseLen = 0;
@@ -3237,15 +3334,13 @@
 	}
 
 	/* Resume I/O */
-	if (CFG_IST(ha, CFG_CTRL_24258081)) {
-		ql_restart_driver(ha);
-	} else {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1)) {
 		EL(ha, "isp_abort_needed for restart\n");
 		ql_awaken_task_daemon(ha, NULL, ISP_ABORT_NEEDED,
 		    DRIVER_STALL);
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -3268,10 +3363,12 @@
 {
 	ql_xioctl_t	*xp = ha->xioctl;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	if (ql_stall_driver(ha, 0) != QL_SUCCESS) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1) &&
+	    ql_stall_driver(ha, 0) != QL_SUCCESS) {
 		EL(ha, "ql_stall_driver failed\n");
+		ql_restart_driver(ha);
 		cmd->Status = EXT_STATUS_BUSY;
 		cmd->DetailStatus = xp->fdesc.flash_size;
 		cmd->ResponseLen = 0;
@@ -3288,7 +3385,7 @@
 		/* Load flash data. */
 		if (cmd->RequestLen > xp->fdesc.flash_size) {
 			cmd->Status = EXT_STATUS_ERR;
-			cmd->DetailStatus =  xp->fdesc.flash_size;
+			cmd->DetailStatus = xp->fdesc.flash_size;
 			EL(ha, "failed, RequestLen=%xh, flash size=%xh\n",
 			    cmd->RequestLen, xp->fdesc.flash_size);
 		} else if (ql_flash_fcode_load(ha,
@@ -3300,15 +3397,13 @@
 	}
 
 	/* Resume I/O */
-	if (CFG_IST(ha, CFG_CTRL_24258081)) {
-		ql_restart_driver(ha);
-	} else {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1)) {
 		EL(ha, "isp_abort_needed for restart\n");
 		ql_awaken_task_daemon(ha, NULL, ISP_ABORT_NEEDED,
 		    DRIVER_STALL);
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -3332,11 +3427,12 @@
 	EXT_LOOPBACK_REQ	plbreq;
 	EXT_LOOPBACK_RSP	plbrsp;
 	ql_mbx_data_t		mr;
-	uint32_t		rval;
-	caddr_t			bp;
+	uint32_t		rval, timer, bpsize;
+	caddr_t			bp, pld;
 	uint16_t		opt;
+	boolean_t		loop_up;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	/* Get loop back request. */
 	if (ddi_copyin((void *)(uintptr_t)cmd->RequestAdr,
@@ -3347,14 +3443,11 @@
 		return;
 	}
 
-	opt = (uint16_t)(plbreq.Options & MBC_LOOPBACK_POINT_MASK);
-
 	/* Check transfer length fits in buffer. */
-	if (plbreq.BufferLength < plbreq.TransferCount &&
-	    plbreq.TransferCount < MAILBOX_BUFFER_SIZE) {
-		EL(ha, "failed, BufferLength=%d, xfercnt=%d, "
-		    "mailbox_buffer_size=%d\n", plbreq.BufferLength,
-		    plbreq.TransferCount, MAILBOX_BUFFER_SIZE);
+	if (plbreq.BufferLength < plbreq.TransferCount) {
+		EL(ha, "failed, BufferLength=%d, xfercnt=%d\n",
+
+		    plbreq.BufferLength, plbreq.TransferCount);
 		cmd->Status = EXT_STATUS_INVALID_PARAM;
 		cmd->ResponseLen = 0;
 		return;
@@ -3361,7 +3454,8 @@
 	}
 
 	/* Allocate command memory. */
-	bp = kmem_zalloc(plbreq.TransferCount, KM_SLEEP);
+	bpsize = plbreq.TransferCount + 4; /* Include opcode size */
+	bp = kmem_zalloc(bpsize, KM_SLEEP);
 	if (bp == NULL) {
 		EL(ha, "failed, kmem_zalloc\n");
 		cmd->Status = EXT_STATUS_NO_MEMORY;
@@ -3368,25 +3462,29 @@
 		cmd->ResponseLen = 0;
 		return;
 	}
+	pld = bp + 4;
+	*bp = 0x10;	/* opcode */
 
 	/* Get loopback data. */
 	if (ql_get_buffer_data((caddr_t)(uintptr_t)plbreq.BufferAddress,
-	    bp, plbreq.TransferCount, mode) != plbreq.TransferCount) {
+	    pld, plbreq.TransferCount, mode) != plbreq.TransferCount) {
 		EL(ha, "failed, ddi_copyin-2\n");
-		kmem_free(bp, plbreq.TransferCount);
+		kmem_free(bp, bpsize);
 		cmd->Status = EXT_STATUS_COPY_ERR;
 		cmd->ResponseLen = 0;
 		return;
 	}
 
-	if ((ha->task_daemon_flags & (QL_LOOP_TRANSITION | DRIVER_STALL)) ||
+	if (LOOP_RECONFIGURE(ha) ||
 	    ql_stall_driver(ha, 0) != QL_SUCCESS) {
 		EL(ha, "failed, LOOP_NOT_READY\n");
-		kmem_free(bp, plbreq.TransferCount);
+		ql_restart_driver(ha);
+		kmem_free(bp, bpsize);
 		cmd->Status = EXT_STATUS_BUSY;
 		cmd->ResponseLen = 0;
 		return;
 	}
+	loop_up = ha->task_daemon_flags & LOOP_DOWN ? B_FALSE : B_TRUE;
 
 	/* Shutdown IP. */
 	if (ha->flags & IP_INITIALIZED) {
@@ -3396,49 +3494,76 @@
 	/* determine topology so we can send the loopback or the echo */
 	/* Echo is supported on 2300's only and above */
 
-	if (CFG_IST(ha, CFG_CTRL_8081)) {
-		if (!(ha->task_daemon_flags & LOOP_DOWN) && opt ==
-		    MBC_LOOPBACK_POINT_EXTERNAL) {
+	ADAPTER_STATE_LOCK(ha);
+	ha->flags |= LOOPBACK_ACTIVE;
+	ADAPTER_STATE_UNLOCK(ha);
+
+	opt = plbreq.Options;
+
+	if (CFG_IST(ha, CFG_FCOE_SUPPORT)) {
+		opt = (uint16_t)(plbreq.Options & MBC_LOOPBACK_POINT_MASK);
+		if (loop_up && opt == MBC_LOOPBACK_POINT_EXTERNAL) {
 			if (plbreq.TransferCount > 252) {
 				EL(ha, "transfer count (%d) > 252\n",
 				    plbreq.TransferCount);
-				kmem_free(bp, plbreq.TransferCount);
+				ql_restart_driver(ha);
+				kmem_free(bp, bpsize);
 				cmd->Status = EXT_STATUS_INVALID_PARAM;
 				cmd->ResponseLen = 0;
 				return;
 			}
 			plbrsp.CommandSent = INT_DEF_LB_ECHO_CMD;
-			rval = ql_diag_echo(ha, 0, bp, plbreq.TransferCount,
+			rval = ql_diag_echo(ha, pld, plbreq.TransferCount,
 			    MBC_ECHO_ELS, &mr);
 		} else {
-			if (CFG_IST(ha, CFG_CTRL_81XX)) {
+			if (CFG_IST(ha, CFG_LOOP_POINT_SUPPORT)) {
 				(void) ql_set_loop_point(ha, opt);
 			}
 			plbrsp.CommandSent = INT_DEF_LB_LOOPBACK_CMD;
-			rval = ql_diag_loopback(ha, 0, bp, plbreq.TransferCount,
+			rval = ql_diag_loopback(ha, pld, plbreq.TransferCount,
 			    opt, plbreq.IterationCount, &mr);
-			if (CFG_IST(ha, CFG_CTRL_81XX)) {
+			if (mr.mb[0] == 0x4005 && mr.mb[1] == 0x17) {
+				(void) ql_abort_isp(ha);
+			}
+			if (CFG_IST(ha, CFG_LOOP_POINT_SUPPORT)) {
 				(void) ql_set_loop_point(ha, 0);
 			}
 		}
 	} else {
-		if (!(ha->task_daemon_flags & LOOP_DOWN) &&
-		    (ha->topology & QL_F_PORT) &&
-		    ha->device_id >= 0x2300) {
-			QL_PRINT_9(CE_CONT, "(%d): F_PORT topology -- using "
-			    "echo\n", ha->instance);
+		if (loop_up && (ha->topology & QL_F_PORT) &&
+		    CFG_IST(ha, CFG_LB_ECHO_SUPPORT)) {
+			QL_PRINT_9(ha, "F_PORT topology -- using "
+			    "echo\n");
 			plbrsp.CommandSent = INT_DEF_LB_ECHO_CMD;
-			rval = ql_diag_echo(ha, 0, bp, plbreq.TransferCount,
-			    (uint16_t)(CFG_IST(ha, CFG_CTRL_8081) ?
-			    MBC_ECHO_ELS : MBC_ECHO_64BIT), &mr);
+			if ((rval = ql_diag_echo(ha, bp, bpsize,
+			    (uint16_t)(CFG_IST(ha, CFG_ISP_FW_TYPE_1) ?
+			    MBC_ECHO_64BIT : MBC_ECHO_ELS), &mr)) !=
+			    QL_SUCCESS) {
+				rval = ql_diag_echo(ha, pld,
+				    plbreq.TransferCount,
+				    (uint16_t)(CFG_IST(ha, CFG_ISP_FW_TYPE_1) ?
+				    MBC_ECHO_64BIT : 0), &mr);
+			}
 		} else {
 			plbrsp.CommandSent = INT_DEF_LB_LOOPBACK_CMD;
-			rval = ql_diag_loopback(ha, 0, bp, plbreq.TransferCount,
+			if (CFG_IST(ha, CFG_ISP_FW_TYPE_1)) {
+				opt = (uint16_t)(opt | MBC_LOOPBACK_64BIT);
+			}
+			rval = ql_diag_loopback(ha, pld, plbreq.TransferCount,
 			    opt, plbreq.IterationCount, &mr);
 		}
 	}
+	ADAPTER_STATE_LOCK(ha);
+	ha->flags &= ~LOOPBACK_ACTIVE;
+	ADAPTER_STATE_UNLOCK(ha);
 
 	ql_restart_driver(ha);
+	if (loop_up && opt == MBC_LOOPBACK_POINT_INTERNAL) {
+		timer = 30;
+		do {
+			delay(100);
+		} while (timer-- && LOOP_NOT_READY(ha));
+	}
 
 	/* Restart IP if it was shutdown. */
 	if (ha->flags & IP_ENABLED && !(ha->flags & IP_INITIALIZED)) {
@@ -3448,7 +3573,7 @@
 
 	if (rval != QL_SUCCESS) {
 		EL(ha, "failed, diagnostic_loopback_mbx=%xh\n", rval);
-		kmem_free(bp, plbreq.TransferCount);
+		kmem_free(bp, bpsize);
 		cmd->Status = EXT_STATUS_MAILBOX;
 		cmd->DetailStatus = rval;
 		cmd->ResponseLen = 0;
@@ -3456,15 +3581,15 @@
 	}
 
 	/* Return loopback data. */
-	if (ql_send_buffer_data(bp, (caddr_t)(uintptr_t)plbreq.BufferAddress,
+	if (ql_send_buffer_data(pld, (caddr_t)(uintptr_t)plbreq.BufferAddress,
 	    plbreq.TransferCount, mode) != plbreq.TransferCount) {
 		EL(ha, "failed, ddi_copyout\n");
-		kmem_free(bp, plbreq.TransferCount);
+		kmem_free(bp, bpsize);
 		cmd->Status = EXT_STATUS_COPY_ERR;
 		cmd->ResponseLen = 0;
 		return;
 	}
-	kmem_free(bp, plbreq.TransferCount);
+	kmem_free(bp, bpsize);
 
 	/* Return loopback results. */
 	plbrsp.BufferAddress = plbreq.BufferAddress;
@@ -3480,7 +3605,8 @@
 		plbrsp.CrcErrorCount = mr.mb[1];
 		plbrsp.DisparityErrorCount = mr.mb[2];
 		plbrsp.FrameLengthErrorCount = mr.mb[3];
-		plbrsp.IterationCountLastError = (mr.mb[19] >> 16) | mr.mb[18];
+		plbrsp.IterationCountLastError =
+		    SHORT_TO_LONG(mr.mb[18], mr.mb[19]);
 	}
 
 	rval = ddi_copyout((void *)&plbrsp,
@@ -3494,7 +3620,7 @@
 	}
 	cmd->ResponseLen = sizeof (EXT_LOOPBACK_RSP);
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -3511,7 +3637,7 @@
  * Context:
  *	Kernel context.
  */
-static int
+int
 ql_set_loop_point(ql_adapter_state_t *ha, uint16_t opt)
 {
 	ql_mbx_data_t	mr;
@@ -3518,7 +3644,7 @@
 	int		rval;
 	uint32_t	timer;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	/*
 	 * We get the current port config, modify the loopback field and
@@ -3530,12 +3656,13 @@
 	}
 	/*
 	 * Set the loopback mode field while maintaining the others.
-	 * Currently only internal or none are supported.
 	 */
-	mr.mb[1] = (uint16_t)(mr.mb[1] &~LOOPBACK_MODE_FIELD_MASK);
+	mr.mb[1] = (uint16_t)(mr.mb[1] & ~LOOPBACK_MODE_FIELD_MASK);
 	if (opt == MBC_LOOPBACK_POINT_INTERNAL) {
-		mr.mb[1] = (uint16_t)(mr.mb[1] |
-		    LOOPBACK_MODE(LOOPBACK_MODE_INTERNAL));
+		mr.mb[1] = (uint16_t)(mr.mb[1] | LOOPBACK_MODE_INTERNAL);
+	} else if (CFG_IST(ha, CFG_CTRL_80XX) &&
+	    opt == MBC_LOOPBACK_POINT_EXTERNAL) {
+		mr.mb[1] = (uint16_t)(mr.mb[1] | LOOPBACK_MODE_EXTERNAL);
 	}
 	/*
 	 * Changing the port configuration will cause the port state to cycle
@@ -3558,7 +3685,7 @@
 		ql_delay(ha, 1000000);
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 
 	return (rval);
 }
@@ -3585,13 +3712,13 @@
 	port_id_t	tmp_fcid;
 	caddr_t		tmp_buf, bptr;
 	uint32_t	copy_len;
-	ql_tgt_t	*tq;
+	ql_tgt_t	*tq = NULL;
 	EXT_RNID_DATA	rnid_data;
 	uint32_t	loop_ready_wait = 10 * 60 * 10;
 	int		rval = 0;
 	uint32_t	local_hba = 0;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (DRIVER_SUSPENDED(ha)) {
 		EL(ha, "failed, LOOP_NOT_READY\n");
@@ -3620,9 +3747,7 @@
 
 	/* Find loop ID of the device */
 	if (tmp_rnid.Addr.Type == EXT_DEF_TYPE_WWNN) {
-		bptr = CFG_IST(ha, CFG_CTRL_24258081) ?
-		    (caddr_t)&ha->init_ctrl_blk.cb24.node_name :
-		    (caddr_t)&ha->init_ctrl_blk.cb.node_name;
+		bptr = (caddr_t)ha->loginparams.node_ww_name.raw_wwn;
 		if (bcmp((void *)bptr, (void *)tmp_rnid.Addr.FcAddr.WWNN,
 		    EXT_DEF_WWN_NAME_SIZE) == 0) {
 			local_hba = 1;
@@ -3631,9 +3756,7 @@
 			    (uint8_t *)tmp_rnid.Addr.FcAddr.WWNN, QLNT_NODE);
 		}
 	} else if (tmp_rnid.Addr.Type == EXT_DEF_TYPE_WWPN) {
-		bptr = CFG_IST(ha, CFG_CTRL_24258081) ?
-		    (caddr_t)&ha->init_ctrl_blk.cb24.port_name :
-		    (caddr_t)&ha->init_ctrl_blk.cb.port_name;
+		bptr = (caddr_t)ha->loginparams.nport_ww_name.raw_wwn;
 		if (bcmp((void *)bptr, (void *)tmp_rnid.Addr.FcAddr.WWPN,
 		    EXT_DEF_WWN_NAME_SIZE) == 0) {
 			local_hba = 1;
@@ -3685,21 +3808,11 @@
 		tmp_buf[1] = (2 * EXT_DEF_WWN_NAME_SIZE);
 		tmp_buf[2] = 0;
 		tmp_buf[3] = sizeof (EXT_RNID_DATA);
-
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
-			bcopy(ha->init_ctrl_blk.cb24.port_name, &tmp_buf[4],
-			    EXT_DEF_WWN_NAME_SIZE);
-			bcopy(ha->init_ctrl_blk.cb24.node_name,
-			    &tmp_buf[4 + EXT_DEF_WWN_NAME_SIZE],
-			    EXT_DEF_WWN_NAME_SIZE);
-		} else {
-			bcopy(ha->init_ctrl_blk.cb.port_name, &tmp_buf[4],
-			    EXT_DEF_WWN_NAME_SIZE);
-			bcopy(ha->init_ctrl_blk.cb.node_name,
-			    &tmp_buf[4 + EXT_DEF_WWN_NAME_SIZE],
-			    EXT_DEF_WWN_NAME_SIZE);
-		}
-
+		bcopy(ha->loginparams.nport_ww_name.raw_wwn, &tmp_buf[4],
+		    EXT_DEF_WWN_NAME_SIZE);
+		bcopy(ha->loginparams.node_ww_name.raw_wwn,
+		    &tmp_buf[4 + EXT_DEF_WWN_NAME_SIZE],
+		    EXT_DEF_WWN_NAME_SIZE);
 		bcopy((uint8_t *)&rnid_data,
 		    &tmp_buf[4 + 2 * EXT_DEF_WWN_NAME_SIZE],
 		    sizeof (EXT_RNID_DATA));
@@ -3762,7 +3875,7 @@
 			EL(ha, "failed, EXT_STATUS_DATA_UNDERRUN\n");
 		} else {
 			cmd->Status = EXT_STATUS_OK;
-			QL_PRINT_9(CE_CONT, "(%d): done\n",
+			QL_PRINT_9(ha, "done\n",
 			    ha->instance);
 		}
 	}
@@ -3788,7 +3901,7 @@
 static void
 ql_set_host_data(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
 {
-	QL_PRINT_9(CE_CONT, "(%d): started, SubCode=%d\n", ha->instance,
+	QL_PRINT_9(ha, "started, SubCode=%d\n",
 	    cmd->SubCode);
 
 	/*
@@ -3827,7 +3940,7 @@
 		EL(ha, "failed, Status=%d\n", cmd->Status);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -3851,7 +3964,7 @@
 {
 	int	out_size = 0;
 
-	QL_PRINT_9(CE_CONT, "(%d): started, SubCode=%d\n", ha->instance,
+	QL_PRINT_9(ha, "started, SubCode=%d\n",
 	    cmd->SubCode);
 
 	/* case off on command subcode */
@@ -3886,6 +3999,9 @@
 	case EXT_SC_GET_FCF_LIST:
 		out_size = sizeof (EXT_FCF_LIST);
 		break;
+	case EXT_SC_GET_PRIV_STATS:
+		out_size = cmd->ResponseLen;
+		break;
 	case EXT_SC_GET_SCSI_ADDR:
 	case EXT_SC_GET_ERR_DETECTIONS:
 	case EXT_SC_GET_BUS_MODE:
@@ -3950,6 +4066,9 @@
 	case EXT_SC_GET_RESOURCE_CNTS:
 		ql_get_resource_counts(ha, cmd, mode);
 		break;
+	case EXT_SC_GET_PRIV_STATS:
+		ql_get_priv_stats(ha, cmd, mode);
+		break;
 	}
 
 	if (cmd->Status != EXT_STATUS_OK) {
@@ -3956,7 +4075,7 @@
 		EL(ha, "failed, Status=%d\n", cmd->Status);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -3983,7 +4102,7 @@
 {
 	int	cnt;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	/* Bypass LUNs that failed. */
 	cnt = ql_report_lun(ha, tq);
@@ -3991,7 +4110,7 @@
 		cnt = ql_inq_scan(ha, tq, ha->maximum_luns_per_target);
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 
 	return (cnt);
 }
@@ -4022,7 +4141,7 @@
 	uint16_t		comp_status;
 	uint8_t			scsi_status_h, scsi_status_l, *reqs;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (DRIVER_SUSPENDED(ha)) {
 		EL(ha, "failed, LOOP_NOT_READY\n");
@@ -4040,7 +4159,7 @@
 	/* Get DMA memory for the IOCB */
 	if (ql_get_dma_mem(ha, &dma_mem, sizeof (ql_rpt_lun_lst_t),
 	    LITTLE_ENDIAN_DMA, QL_DMA_RING_ALIGN) != QL_SUCCESS) {
-		cmn_err(CE_WARN, "%s(%d): DMA memory "
+		cmn_err(CE_WARN, "%s(%d) DMA memory "
 		    "alloc failed", QL_NAME, ha->instance);
 		kmem_free(pkt, pkt_size);
 		return (0);
@@ -4047,7 +4166,7 @@
 	}
 
 	for (retries = 0; retries < 4; retries++) {
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
+		if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 			pkt->cmd24.entry_type = IOCB_CMD_TYPE_7;
 			pkt->cmd24.entry_count = 1;
 
@@ -4091,13 +4210,13 @@
 
 			/* Load total byte count. */
 			/* Load data descriptor. */
-			pkt->cmd24.dseg_0_address[0] = (uint32_t)
+			pkt->cmd24.dseg.address[0] = (uint32_t)
 			    LE_32(LSD(dma_mem.cookie.dmac_laddress));
-			pkt->cmd24.dseg_0_address[1] = (uint32_t)
+			pkt->cmd24.dseg.address[1] = (uint32_t)
 			    LE_32(MSD(dma_mem.cookie.dmac_laddress));
 			pkt->cmd24.total_byte_count =
 			    LE_32(sizeof (ql_rpt_lun_lst_t));
-			pkt->cmd24.dseg_0_length =
+			pkt->cmd24.dseg.length =
 			    LE_32(sizeof (ql_rpt_lun_lst_t));
 		} else if (CFG_IST(ha, CFG_ENABLE_64BIT_ADDRESSING)) {
 			pkt->cmd3.entry_type = IOCB_CMD_TYPE_3;
@@ -4122,11 +4241,11 @@
 			    LSB(LSW(sizeof (ql_rpt_lun_lst_t)));
 			pkt->cmd3.byte_count =
 			    LE_32(sizeof (ql_rpt_lun_lst_t));
-			pkt->cmd3.dseg_0_address[0] = (uint32_t)
+			pkt->cmd3.dseg[0].address[0] = (uint32_t)
 			    LE_32(LSD(dma_mem.cookie.dmac_laddress));
-			pkt->cmd3.dseg_0_address[1] = (uint32_t)
+			pkt->cmd3.dseg[0].address[1] = (uint32_t)
 			    LE_32(MSD(dma_mem.cookie.dmac_laddress));
-			pkt->cmd3.dseg_0_length =
+			pkt->cmd3.dseg[0].length =
 			    LE_32(sizeof (ql_rpt_lun_lst_t));
 		} else {
 			pkt->cmd.entry_type = IOCB_CMD_TYPE_2;
@@ -4151,9 +4270,9 @@
 			    LSB(LSW(sizeof (ql_rpt_lun_lst_t)));
 			pkt->cmd.byte_count =
 			    LE_32(sizeof (ql_rpt_lun_lst_t));
-			pkt->cmd.dseg_0_address = (uint32_t)
+			pkt->cmd.dseg[0].address = (uint32_t)
 			    LE_32(LSD(dma_mem.cookie.dmac_laddress));
-			pkt->cmd.dseg_0_length =
+			pkt->cmd.dseg[0].length =
 			    LE_32(sizeof (ql_rpt_lun_lst_t));
 		}
 
@@ -4167,7 +4286,7 @@
 		ddi_rep_get8(dma_mem.acc_handle, (uint8_t *)rpt,
 		    (uint8_t *)dma_mem.bp, dma_mem.size, DDI_DEV_AUTOINCR);
 
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
+		if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 			pkt->sts24.entry_status = (uint8_t)
 			    (pkt->sts24.entry_status & 0x3c);
 			comp_status = (uint16_t)LE_16(pkt->sts24.comp_status);
@@ -4235,7 +4354,7 @@
 		EL(ha, "failed=%xh\n", rval);
 		rval = 0;
 	} else {
-		QL_PRINT_9(CE_CONT, "(%d): LUN list\n", ha->instance);
+		QL_PRINT_9(ha, "LUN list\n");
 		QL_DUMP_9(rpt, 8, rpt->hdr.len + 8);
 		rval = (int)(BE_32(rpt->hdr.len) / 8);
 	}
@@ -4243,7 +4362,7 @@
 	kmem_free(pkt, pkt_size);
 	ql_free_dma_resource(ha, &dma_mem);
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 
 	return (rval);
 }
@@ -4271,7 +4390,7 @@
 	uint8_t		*inq;
 	uint32_t	pkt_size;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	pkt_size = sizeof (ql_mbx_iocb_t) + INQ_DATA_SIZE;
 	pkt = kmem_zalloc(pkt_size, KM_SLEEP);
@@ -4308,9 +4427,9 @@
 				tq->flags |= TQF_TAPE_DEVICE;
 				break;
 			default:
-				QL_PRINT_9(CE_CONT, "(%d): failed, "
+				QL_PRINT_9(ha, "failed, "
 				    "unsupported device id=%xh, lun=%d, "
-				    "type=%xh\n", ha->instance, tq->loop_id,
+				    "type=%xh\n", tq->loop_id,
 				    lun, *inq);
 				break;
 			}
@@ -4326,7 +4445,7 @@
 
 	kmem_free(pkt, pkt_size);
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 
 	return (cnt);
 }
@@ -4350,7 +4469,7 @@
  */
 static int
 ql_inq(ql_adapter_state_t *ha, ql_tgt_t *tq, int lun, ql_mbx_iocb_t *pkt,
-    uint8_t inq_len)
+    uint32_t inq_len)
 {
 	dma_mem_t	dma_mem;
 	int		rval, retries;
@@ -4358,8 +4477,10 @@
 	uint16_t	comp_status;
 	uint8_t		scsi_status_h, scsi_status_l, *reqs;
 	caddr_t		inq_data;
+	uint64_t	lun_addr;
+	fcp_ent_addr_t	*fcp_ent_addr = (fcp_ent_addr_t *)&lun_addr;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (DRIVER_SUSPENDED(ha)) {
 		EL(ha, "failed, loop down\n");
@@ -4374,19 +4495,35 @@
 	/* Get DMA memory for the IOCB */
 	if (ql_get_dma_mem(ha, &dma_mem, inq_len,
 	    LITTLE_ENDIAN_DMA, QL_DMA_RING_ALIGN) != QL_SUCCESS) {
-		cmn_err(CE_WARN, "%s(%d): DMA memory "
+		cmn_err(CE_WARN, "%s(%d) DMA memory "
 		    "alloc failed", QL_NAME, ha->instance);
 		return (0);
 	}
 
 	for (retries = 0; retries < 4; retries++) {
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
+		if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 			pkt->cmd24.entry_type = IOCB_CMD_TYPE_7;
 			pkt->cmd24.entry_count = 1;
 
 			/* Set LUN number */
-			pkt->cmd24.fcp_lun[2] = LSB(lun);
-			pkt->cmd24.fcp_lun[3] = MSB(lun);
+			lun_addr = ql_get_lun_addr(tq, lun);
+			fcp_ent_addr = (fcp_ent_addr_t *)&lun_addr;
+			pkt->cmd24.fcp_lun[2] =
+			    lobyte(fcp_ent_addr->ent_addr_0);
+			pkt->cmd24.fcp_lun[3] =
+			    hibyte(fcp_ent_addr->ent_addr_0);
+			pkt->cmd24.fcp_lun[0] =
+			    lobyte(fcp_ent_addr->ent_addr_1);
+			pkt->cmd24.fcp_lun[1] =
+			    hibyte(fcp_ent_addr->ent_addr_1);
+			pkt->cmd24.fcp_lun[6] =
+			    lobyte(fcp_ent_addr->ent_addr_2);
+			pkt->cmd24.fcp_lun[7] =
+			    hibyte(fcp_ent_addr->ent_addr_2);
+			pkt->cmd24.fcp_lun[4] =
+			    lobyte(fcp_ent_addr->ent_addr_3);
+			pkt->cmd24.fcp_lun[5] =
+			    hibyte(fcp_ent_addr->ent_addr_3);
 
 			/* Set N_port handle */
 			pkt->cmd24.n_port_hdl = (uint16_t)LE_16(tq->loop_id);
@@ -4404,7 +4541,7 @@
 
 			/* Load SCSI CDB */
 			pkt->cmd24.scsi_cdb[0] = SCMD_INQUIRY;
-			pkt->cmd24.scsi_cdb[4] = inq_len;
+			pkt->cmd24.scsi_cdb[4] = LSB(LSW(inq_len));
 			for (cnt = 0; cnt < MAX_CMDSZ; cnt += 4) {
 				ql_chg_endian((uint8_t *)&pkt->cmd24.scsi_cdb
 				    + cnt, 4);
@@ -4423,11 +4560,11 @@
 			pkt->cmd24.total_byte_count = LE_32(inq_len);
 
 			/* Load data descriptor. */
-			pkt->cmd24.dseg_0_address[0] = (uint32_t)
+			pkt->cmd24.dseg.address[0] = (uint32_t)
 			    LE_32(LSD(dma_mem.cookie.dmac_laddress));
-			pkt->cmd24.dseg_0_address[1] = (uint32_t)
+			pkt->cmd24.dseg.address[1] = (uint32_t)
 			    LE_32(MSD(dma_mem.cookie.dmac_laddress));
-			pkt->cmd24.dseg_0_length = LE_32(inq_len);
+			pkt->cmd24.dseg.length = LE_32(inq_len);
 		} else if (CFG_IST(ha, CFG_ENABLE_64BIT_ADDRESSING)) {
 			pkt->cmd3.entry_type = IOCB_CMD_TYPE_3;
 			cnt = CMD_TYPE_3_DATA_SEGMENTS;
@@ -4444,14 +4581,14 @@
 			pkt->cmd3.control_flags_l = CF_DATA_IN | CF_STAG;
 			pkt->cmd3.timeout = LE_16(15);
 			pkt->cmd3.scsi_cdb[0] = SCMD_INQUIRY;
-			pkt->cmd3.scsi_cdb[4] = inq_len;
+			pkt->cmd3.scsi_cdb[4] = LSB(LSW(inq_len));
 			pkt->cmd3.dseg_count = LE_16(1);
 			pkt->cmd3.byte_count = LE_32(inq_len);
-			pkt->cmd3.dseg_0_address[0] = (uint32_t)
+			pkt->cmd3.dseg[0].address[0] = (uint32_t)
 			    LE_32(LSD(dma_mem.cookie.dmac_laddress));
-			pkt->cmd3.dseg_0_address[1] = (uint32_t)
+			pkt->cmd3.dseg[0].address[1] = (uint32_t)
 			    LE_32(MSD(dma_mem.cookie.dmac_laddress));
-			pkt->cmd3.dseg_0_length = LE_32(inq_len);
+			pkt->cmd3.dseg[0].length = LE_32(inq_len);
 		} else {
 			pkt->cmd.entry_type = IOCB_CMD_TYPE_2;
 			cnt = CMD_TYPE_2_DATA_SEGMENTS;
@@ -4468,12 +4605,12 @@
 			pkt->cmd.control_flags_l = CF_DATA_IN | CF_STAG;
 			pkt->cmd.timeout = LE_16(15);
 			pkt->cmd.scsi_cdb[0] = SCMD_INQUIRY;
-			pkt->cmd.scsi_cdb[4] = inq_len;
+			pkt->cmd.scsi_cdb[4] = LSB(LSW(inq_len));
 			pkt->cmd.dseg_count = LE_16(1);
 			pkt->cmd.byte_count = LE_32(inq_len);
-			pkt->cmd.dseg_0_address = (uint32_t)
+			pkt->cmd.dseg[0].address = (uint32_t)
 			    LE_32(LSD(dma_mem.cookie.dmac_laddress));
-			pkt->cmd.dseg_0_length = LE_32(inq_len);
+			pkt->cmd.dseg[0].length = LE_32(inq_len);
 		}
 
 /*		rval = ql_issue_mbx_iocb(ha, (caddr_t)pkt, pkt_size); */
@@ -4487,7 +4624,7 @@
 		ddi_rep_get8(dma_mem.acc_handle, (uint8_t *)inq_data,
 		    (uint8_t *)dma_mem.bp, dma_mem.size, DDI_DEV_AUTOINCR);
 
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
+		if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 			pkt->sts24.entry_status = (uint8_t)
 			    (pkt->sts24.entry_status & 0x3c);
 			comp_status = (uint16_t)LE_16(pkt->sts24.comp_status);
@@ -4542,7 +4679,7 @@
 	}
 	ql_free_dma_resource(ha, &dma_mem);
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 
 	return (rval);
 }
@@ -4570,7 +4707,7 @@
 
 	for (cnt = 0; cnt < size; cnt++) {
 		if (ddi_copyin(src++, dst++, 1, mode) != 0) {
-			QL_PRINT_2(CE_CONT, "failed, ddi_copyin\n");
+			QL_PRINT_2(NULL, "failed, ddi_copyin\n");
 			break;
 		}
 	}
@@ -4601,7 +4738,7 @@
 
 	for (cnt = 0; cnt < size; cnt++) {
 		if (ddi_copyout(src++, dst++, 1, mode) != 0) {
-			QL_PRINT_2(CE_CONT, "failed, ddi_copyin\n");
+			QL_PRINT_2(NULL, "failed, ddi_copyin\n");
 			break;
 		}
 	}
@@ -4660,7 +4797,7 @@
 				}
 				break;
 			default:
-				EL(ha, "failed, invalid type=%d\n",  type);
+				EL(ha, "failed, invalid type=%d\n", type);
 				return (NULL);
 			}
 		}
@@ -4691,10 +4828,10 @@
 	flash_desc_t	*fdesc;
 	ql_xioctl_t	*xp = ha->xioctl;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (ha->flash_desc_addr == 0) {
-		QL_PRINT_9(CE_CONT, "(%d): desc ptr=0\n", ha->instance);
+		QL_PRINT_9(ha, "desc ptr=0\n");
 		return (QL_FUNCTION_FAILED);
 	}
 
@@ -4743,7 +4880,7 @@
 	bcopy(fdesc, &xp->fdesc, sizeof (flash_desc_t));
 	kmem_free(fdesc, sizeof (flash_desc_t));
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 
 	return (QL_SUCCESS);
 }
@@ -4772,16 +4909,18 @@
 		return (rval);
 	}
 
-	if (CFG_IST(ha, CFG_CTRL_2200) && !ha->subven_id) {
+	if (CFG_IST(ha, CFG_CTRL_22XX) && !ha->subven_id) {
 		return (QL_FUNCTION_FAILED);
 	}
 
-	if (CFG_IST(ha, CFG_CTRL_258081)) {
+	if (CFG_IST(ha, CFG_CTRL_252780818283)) {
 		/*
 		 * Temporarily set the ha->xioctl->fdesc.flash_size to
 		 * 25xx flash size to avoid failing of ql_dump_focde.
 		 */
-		if (CFG_IST(ha, CFG_CTRL_8021)) {
+		if (CFG_IST(ha, CFG_CTRL_278083)) {
+			ha->xioctl->fdesc.flash_size = 0x1000000;
+		} else if (CFG_IST(ha, CFG_CTRL_82XX)) {
 			ha->xioctl->fdesc.flash_size = 0x800000;
 		} else if (CFG_IST(ha, CFG_CTRL_25XX)) {
 			ha->xioctl->fdesc.flash_size = 0x200000;
